Index: java/main/src/main/java/com/framsticks/gui/controls/SliderControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/SliderControl.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/controls/SliderControl.java	(revision 101)
@@ -18,4 +18,5 @@
 import org.apache.logging.log4j.LogManager;
 
+import com.framsticks.gui.Gui;
 import com.framsticks.params.types.DecimalParam;
 import com.framsticks.params.types.FloatParam;
@@ -98,10 +99,5 @@
 		slider.setPaintTicks(true);
 
-		this.setLayout(new BoxLayout(this, BoxLayout.LINE_AXIS));
-		this.setAlignmentX(Box.CENTER_ALIGNMENT);
-		this.setAlignmentY(Box.CENTER_ALIGNMENT);
-
-		JPanel sliderPanel = new JPanel();
-		// sliderPanel.setLayout(new BoxLayout(sliderPanel, BoxLayout.LINE_AXIS));
+
 
 
@@ -140,12 +136,11 @@
 		}));
 
-		JPanel sVPanel = new JPanel();
-		sVPanel.setLayout(new BoxLayout(sVPanel, BoxLayout.LINE_AXIS));
-		sVPanel.add(text);
-		Layout.copyComponentDimensions(sVPanel, text);
-
-		JPanel sPanel = new JPanel();
-		sPanel.setLayout(new BoxLayout(sPanel, BoxLayout.LINE_AXIS));
-
+		JPanel valuePanel = new JPanel();
+		valuePanel.setLayout(new BoxLayout(valuePanel, BoxLayout.LINE_AXIS));
+		valuePanel.add(text);
+		Layout.copyComponentDimensions(valuePanel, text);
+
+
+		JPanel sliderPanel = new JPanel();
 		sliderPanel.setLayout(new BorderLayout());
 		sliderPanel.add(slider, BorderLayout.CENTER);
@@ -153,8 +148,10 @@
 		sliderPanel.setMinimumSize(new Dimension(0, 60));
 
-		sPanel.add(sVPanel);
-		sPanel.add(sliderPanel);
-
-		this.add(sPanel);
+
+		this.setLayout(new BoxLayout(this, BoxLayout.LINE_AXIS));
+		this.setAlignmentX(Box.CENTER_ALIGNMENT);
+		this.setAlignmentY(Box.CENTER_ALIGNMENT);
+
+		Gui.addLeftToLabel(this, valuePanel, sliderPanel);
 	}
 
Index: java/main/src/main/java/com/framsticks/gui/controls/TextAreaControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/TextAreaControl.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/controls/TextAreaControl.java	(revision 101)
@@ -1,4 +1,5 @@
 package com.framsticks.gui.controls;
 
+import com.framsticks.gui.Gui;
 import com.framsticks.params.PrimitiveParam;
 
@@ -27,5 +28,6 @@
 		textArea.setMaximumSize(new Dimension(Integer.MAX_VALUE, maxSize));
 
-		this.revalidate();
+		Gui.setupTitledControl(this, textScrollPane);
+		// this.revalidate();
 	}
 
Index: java/main/src/main/java/com/framsticks/gui/controls/TextFieldControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/TextFieldControl.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/controls/TextFieldControl.java	(revision 101)
@@ -1,4 +1,5 @@
 package com.framsticks.gui.controls;
 
+import com.framsticks.gui.Gui;
 import com.framsticks.params.PrimitiveParam;
 import com.framsticks.util.lang.Strings;
@@ -33,5 +34,5 @@
 		addDefaultDocumentListener(textField);
 
-		addAsOnlyChild(textField);
+		Gui.addLeftToLabel(this, textField);
 	}
 
Index: java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java	(revision 101)
@@ -12,4 +12,5 @@
 import com.framsticks.util.lang.FlagsUtil;
 import com.framsticks.util.swing.TooltipConstructor;
+// import static com.framsticks.core.TreeOperations.*;
 
 /**
@@ -20,9 +21,4 @@
 	private static final Logger log =
 		LogManager.getLogger(ValueControl.class);
-
-	/**
-	 *
-	 */
-	protected ValueControlListener listener;
 
 	public ValueControl(PrimitiveParam<?> primitiveParam) {
@@ -64,10 +60,6 @@
 	public abstract Object pullValueFromUserInterface();
 
-	public void setListener(ValueControlListener listener) {
-		this.listener = listener;
-	}
-
 	protected Object filterValueThroughConstraints(Object candidate) {
-		Object oldValue = pullValueFromUserInterface();
+		Object oldValue = pullValueFromUserInterface();//bindAccess(owner.getCurrentPath()).get(getParam(), Object.class);
 		try {
 			ReassignResult<?> res = getParam().reassign(candidate, oldValue);
@@ -92,8 +84,5 @@
 	protected boolean notifyOfChange() {
 		if (!programmaticChange) {
-			if (listener == null) {
-				return true;
-			}
-			return listener.onChange(getCurrentValue());
+			return owner.onValueChange(this, getCurrentValue());
 		}
 		return true;
Index: java/main/src/main/java/com/framsticks/gui/table/AbstractTableModel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/table/AbstractTableModel.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/gui/table/AbstractTableModel.java	(revision 101)
@@ -0,0 +1,32 @@
+package com.framsticks.gui.table;
+
+import java.util.LinkedList;
+import java.util.List;
+
+import javax.swing.event.TableModelEvent;
+import javax.swing.event.TableModelListener;
+
+public abstract class AbstractTableModel implements javax.swing.table.TableModel {
+
+	protected final List<TableModelListener> listeners = new LinkedList<>();
+
+	@Override
+	public void addTableModelListener(TableModelListener listener) {
+		listeners.add(listener);
+	}
+
+	@Override
+	public void removeTableModelListener(TableModelListener listener) {
+		listeners.remove(listener);
+	}
+
+	protected void notifyAll(TableModelEvent event) {
+		for (TableModelListener l : listeners) {
+			l.tableChanged(event);
+		}
+	}
+
+	public void refreshAll() {
+		notifyAll(new TableModelEvent(this));
+	}
+}
Index: java/main/src/main/java/com/framsticks/gui/table/ListPanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/table/ListPanel.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/table/ListPanel.java	(revision 101)
@@ -54,4 +54,5 @@
 		table = new JTable(tableModel);
 		tableModel.setupTable();
+		table.setShowGrid(false);
 
 		scrollPane = new JScrollPane(table);
@@ -72,6 +73,11 @@
 
 	@Override
+	protected void revertChanges() {
+	}
+
+	@Override
 	public void pullValuesFromLocalToUser(Access access) {
 		tableModel.attachSource(Casting.throwCast(ListAccess.class, access));
+		refreshControlButtons();
 	}
 
@@ -87,3 +93,4 @@
 		return table;
 	}
+
 }
Index: java/main/src/main/java/com/framsticks/gui/table/PrimitiveColumn.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/table/PrimitiveColumn.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/table/PrimitiveColumn.java	(revision 101)
@@ -2,5 +2,5 @@
 
 import com.framsticks.params.PrimitiveParam;
-import com.framsticks.util.UnsupportedOperationException;
+import com.framsticks.util.FramsticksUnsupportedOperationException;
 
 public class PrimitiveColumn extends Column {
@@ -31,5 +31,5 @@
 	@Override
 	public int setValueAt(int rowIndex, Object value) {
-		throw new UnsupportedOperationException().msg("setting value in table");
+		throw new FramsticksUnsupportedOperationException().msg("setting value in table");
 	}
 
Index: java/main/src/main/java/com/framsticks/gui/table/TableModel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/table/TableModel.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/table/TableModel.java	(revision 101)
@@ -3,5 +3,4 @@
 import java.util.ArrayList;
 import java.util.Collections;
-import java.util.LinkedList;
 import java.util.List;
 
@@ -10,6 +9,4 @@
 import javax.swing.JTable;
 import javax.swing.UIManager;
-import javax.swing.event.TableModelEvent;
-import javax.swing.event.TableModelListener;
 
 import org.apache.logging.log4j.Logger;
@@ -23,9 +20,8 @@
 import com.framsticks.util.lang.Casting;
 
-public class TableModel implements javax.swing.table.TableModel {
+public class TableModel extends AbstractTableModel {
 
 	private static final Logger log = LogManager.getLogger(TableModel.class);
 
-	protected List<TableModelListener> listeners = new LinkedList<>();
 	protected ListAccess access;
 	protected Access elementAccess;
@@ -52,9 +48,4 @@
 	}
 
-	protected void refreshAll() {
-		for (TableModelListener l : listeners) {
-			l.tableChanged(new TableModelEvent(this));
-		}
-	}
 
 	/**
@@ -74,8 +65,4 @@
 	}
 
-	@Override
-	public void addTableModelListener(TableModelListener listener) {
-		listeners.add(listener);
-	}
 
 	@Override
@@ -114,8 +101,4 @@
 	}
 
-	@Override
-	public void removeTableModelListener(TableModelListener listener) {
-		listeners.remove(listener);
-	}
 
 
Index: java/main/src/main/java/com/framsticks/gui/tree/TreeModel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/tree/TreeModel.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/tree/TreeModel.java	(revision 101)
@@ -17,4 +17,5 @@
 import com.framsticks.core.Node;
 import com.framsticks.core.Path;
+import com.framsticks.core.SideNoteKey;
 import com.framsticks.core.TreeOperations;
 import com.framsticks.gui.Frame;
@@ -24,10 +25,10 @@
 import com.framsticks.params.ListAccess;
 import com.framsticks.params.PrimitiveParam;
-import com.framsticks.params.Util;
+import com.framsticks.params.ParamsUtil;
 import com.framsticks.params.ValueParam;
 import com.framsticks.params.types.EventParam;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.Misc;
-import com.framsticks.util.UnsupportedOperationException;
+import com.framsticks.util.FramsticksUnsupportedOperationException;
 import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.lang.Casting;
@@ -91,5 +92,5 @@
 	@Override
 	public void valueForPathChanged(TreePath path, Object value) {
-		throw new UnsupportedOperationException().msg("changing value of tree node");
+		throw new FramsticksUnsupportedOperationException().msg("changing value of tree node");
 	}
 
@@ -133,5 +134,5 @@
 	public TreeModelEvent prepareModelEventRegarding(Access access, String id, TreePath treeListPath) {
 
-		int number = Util.getNumberOfCompositeParamChild(access, access.get(id, Object.class));
+		int number = ParamsUtil.getNumberOfCompositeParamChild(access, access.get(id, Object.class));
 		if (number == -1) {
 			log.debug("encountered minor tree inconsistency in {}", treeListPath);
@@ -438,5 +439,5 @@
 
 
-	protected final Object createdTag = new Object();
+	protected final SideNoteKey<Boolean> createdTag = SideNoteKey.make(Boolean.class);
 
 
Index: java/main/src/main/java/com/framsticks/gui/tree/TreeNode.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/tree/TreeNode.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/tree/TreeNode.java	(revision 101)
@@ -4,5 +4,4 @@
 import java.util.Iterator;
 import java.util.LinkedList;
-import java.util.List;
 
 import org.apache.logging.log4j.LogManager;
@@ -11,4 +10,5 @@
 import com.framsticks.core.Node;
 import com.framsticks.core.Path;
+import com.framsticks.core.SideNoteKey;
 import com.framsticks.core.Tree;
 import com.framsticks.gui.Frame;
@@ -59,10 +59,10 @@
 		hashCode = System.identityHashCode(path.getTopObject());
 
-		if (getTree().getSideNote(path.getTopObject(), getTreeModel().createdTag, Object.class) == getTreeModel().createdTag) {
+		if (isMarked(path.getTree(), path.getTopObject(), getTreeModel().createdTag, false)) {
 			return;
 		}
 
 		// path.getTree().putSideNote(path.getTopObject(), Textual.class, path.getTextual());
-		path.getTree().putSideNote(path.getTopObject(), getTreeModel().createdTag, getTreeModel().createdTag);
+		mark(path.getTree(), path.getTopObject(), getTreeModel().createdTag, true);
 
 		/** Iterate over all EventParams and for matching ValueParams register listeners. */
@@ -239,5 +239,5 @@
 		}
 		Access access = bindAccessForTreeObject(child);
-		CompositeParam param = getTree().getSideNote(child, CompositeParam.class, CompositeParam.class);
+		CompositeParam param = getTree().getSideNote(child, Path.OBJECT_PARAM_KEY);
 		String name = param.getId();
 
@@ -262,32 +262,20 @@
 	}
 
-	// public static class Textual {
-	// }
 
 	public String getTextual() {
 		return textual;
-		// return getTree().getSideNote(lock(), Textual.class, String.class);
-	}
-
-	protected final Object listenersTag = new Object();
-
-	public List<EventListener<?>> getListeners() {
-		@SuppressWarnings("unchecked")
-		List<EventListener<?>> result = getTree().getSideNote(lock(), listenersTag, List.class);
-		if (result == null) {
-			result = new LinkedList<>();
-			getTree().putSideNote(lock(), listenersTag, result);
-		}
-
-		return result;
-	}
+	}
+
+	@SuppressWarnings("rawtypes")
+	protected final SideNoteKey<LinkedList> listenersTag = SideNoteKey.make(LinkedList.class);
 
 	protected <A> void tryAddListener(final Path path, final EventParam eventParam, Class<A> argumentType, final EventListener<A> listener) {
 		getTree().addListener(path, eventParam, listener, argumentType, new FutureHandler<Void>(getFrame()) {
+			@SuppressWarnings("unchecked")
 			@Override
 			protected void result(Void result) {
 				assert getFrame().isActive();
 				log.debug("registered gui listener for {} at {}", eventParam, path);
-				getListeners().add(listener);
+				getOrCreateSideNote(getTree(), lock(), listenersTag).add(listener);
 			}
 		});
Index: java/main/src/main/java/com/framsticks/hosting/Cli.java
===================================================================
--- java/main/src/main/java/com/framsticks/hosting/Cli.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/hosting/Cli.java	(revision 101)
@@ -58,5 +58,7 @@
 				client.connection.sendFile(
 						"event " + event.pathToEvent + " " + event.name,
-						ClientAtServer.printToFile("", tree.getRegistry().createAccess(argument.getClass()).select(argument))
+						ClientAtServer.printToFile("", tree.getRegistry().createAccess(argument.getClass()).select(argument)),
+						null,
+						client
 					);
 			}
Index: java/main/src/main/java/com/framsticks/hosting/Server.java
===================================================================
--- java/main/src/main/java/com/framsticks/hosting/Server.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/hosting/Server.java	(revision 101)
@@ -6,4 +6,5 @@
 
 import com.framsticks.core.Tree;
+import com.framsticks.params.ParamFlags;
 import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
@@ -17,5 +18,4 @@
 import com.framsticks.util.dispatching.JoinableState;
 import com.framsticks.util.dispatching.RunAt;
-import com.framsticks.util.dispatching.Task;
 import com.framsticks.util.dispatching.ThrowExceptionHandler;
 
@@ -24,4 +24,6 @@
 import java.net.ServerSocket;
 import java.net.Socket;
+import java.util.TimerTask;
+
 import com.framsticks.util.dispatching.Thread;
 
@@ -61,5 +63,5 @@
 	 * @param port the port to set
 	 */
-	@ParamAnnotation
+	@ParamAnnotation(flags = ParamFlags.USERREADONLY)
 	public void setPort(int port) {
 		this.port = port;
@@ -76,5 +78,5 @@
 			log.debug("exception caught during socket closing: ", e);
 		}
-		finish();
+		finishJoinable();
 	}
 
@@ -150,18 +152,25 @@
 
 	protected void tryBind(int when) {
-		acceptThread.dispatch(new Task<Accept>(ThrowExceptionHandler.getInstance(), when) {
+		Dispatching.getTimer().schedule(new TimerTask() {
+
 			@Override
-			protected void runAt() {
-				try {
-					acceptSocket.bind(new InetSocketAddress(port));
-					log.debug("started accepting on port {}", port);
-					acceptNext();
-					return;
-				} catch (IOException e) {
-					log.warn("failed to accept on port {} (repeating): ", port, e);
-				}
-				tryBind(1000);
+			public void run() {
+				acceptThread.dispatch(new RunAt<Accept>(ThrowExceptionHandler.getInstance()) {
+					@Override
+					protected void runAt() {
+						try {
+							acceptSocket.bind(new InetSocketAddress(port));
+							log.debug("started accepting on port {}", port);
+							acceptNext();
+							return;
+						} catch (IOException e) {
+							log.warn("failed to accept on port {} (repeating): ", port, e);
+						}
+						tryBind(1000);
+					}
+				});
 			}
-		});
+
+		}, when);
 	}
 
@@ -178,45 +187,3 @@
 	}
 
-	// @Override
-	// public FramsClass getInfoFromCache(String id) {
-	//	assert isActive();
-	//	if (id == null) {
-	//		return null;
-	//	}
-	//	FramsClass cached = registry.getFramsClass(id);
-	//	if (cached != null) {
-	//		return cached;
-	//	}
-	//	try {
-	//		Class<?> nativeClass = Class.forName(id);
-	//		FramsClass framsClass = FramsClass.build().forClass(nativeClass);
-
-	//		if (!framsClass.getId().equals(id)) {
-	//			log.error("no matching id");
-	//			return null;
-	//		}
-
-	//		registry.registerReflectedClass(null, id, nativeClass);
-	//		registry.putFramsClass(framsClass);
-	//		return framsClass;
-	//	} catch (ClassNotFoundException ignored) {
-	//	} catch (ConstructionException e) {
-	//		log.error("failed to use info from cache: {}", e);
-	//	}
-
-	//	return null;
-	// }
-
-	// @Override
-	// protected void fetchInfo(Path path, Future<FramsClass> future) {
-	//	assert isActive();
-
-	//	FramsClass framsClass = getInfoFromCache(path.getTop().getObject().getClass().getCanonicalName());
-	//	if (framsClass == null) {
-	//		log.error("failed to create frams class for: {}", path.getTop().getObject().getClass());
-	//		future.result(null, new Exception());
-	//		return;
-	//	}
-	//	future.result(framsClass, null);
-	// }
 }
Index: java/main/src/main/java/com/framsticks/model/ModelBuilder.java
===================================================================
--- java/main/src/main/java/com/framsticks/model/ModelBuilder.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/model/ModelBuilder.java	(revision 101)
@@ -7,5 +7,5 @@
 
 import com.framsticks.model.f0.Schema;
-import com.framsticks.params.Util;
+import com.framsticks.params.ParamsUtil;
 import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
@@ -35,5 +35,5 @@
 			}
 			F0Parser parser = new F0Parser(schema, stream);
-			components.addAll(Util.stripAccess(parser.parse(), ModelComponent.class));
+			components.addAll(ParamsUtil.stripAccess(parser.parse(), ModelComponent.class));
 		}
 		return build();
Index: java/main/src/main/java/com/framsticks/params/AbstractUniqueObject.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/AbstractUniqueObject.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/params/AbstractUniqueObject.java	(revision 101)
@@ -0,0 +1,27 @@
+package com.framsticks.params;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+
+@FramsClassAnnotation
+public abstract class AbstractUniqueObject implements UniqueObject {
+
+	protected String uid;
+
+	/**
+	 * @return the uid
+	 */
+	@ParamAnnotation
+	public String getUid() {
+		return uid;
+	}
+
+	/**
+	 * @param uid the uid to set
+	 */
+	@ParamAnnotation
+	public void setUid(String uid) {
+		this.uid = uid;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/params/Access.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Access.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/params/Access.java	(revision 101)
@@ -44,19 +44,5 @@
 	void regRemove(EventParam param, EventListener<?> listener);
 
-	void setDefault(boolean numericOnly);
-
-	void setDefault(int i, boolean numericOnly);
-
-	void setMin();
-
-	void setMin(int i);
-
-	void setMax();
-
-	void setMax(int i);
-
 	void save(SinkInterface sink);
-
-	void load(SourceInterface stream);
 
 	/**
@@ -69,5 +55,5 @@
 	Object getSelected();
 
-	Access cloneAccess() throws ConstructionException;
+	Access cloneAccess();
 
 	Object createAccessee();
Index: java/main/src/main/java/com/framsticks/params/AccessOperations.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/AccessOperations.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/params/AccessOperations.java	(revision 101)
@@ -0,0 +1,181 @@
+package com.framsticks.params;
+
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.lang.Containers;
+import com.framsticks.util.lang.Holder;
+// import com.framsticks.util.lang.Containers;
+
+import static com.framsticks.params.SetStateFlags.*;
+
+public final class AccessOperations {
+
+	private final static Logger log = LogManager.getLogger(SimpleAbstractAccess.class.getName());
+
+	/**
+	 *
+	 */
+	private AccessOperations() {
+	}
+
+	/**
+	 * Simple String key, value class.
+	 */
+	public static class Entry {
+
+		public final String key;
+		public final String value;
+
+		public Entry(String key, String value) {
+			this.key = key;
+			this.value = value;
+		}
+
+		@Override
+		public String toString() {
+			return key + " = " + value;
+		}
+	}
+
+	private static Entry readEntry(Source source) {
+
+		String line;
+		String key = null;
+		StringBuilder value = null;
+		while ((line = source.readLine()) != null) {
+			if (key == null) {
+				int colonIndex = line.indexOf(':');
+				if (colonIndex == -1) {
+					return null;
+				}
+				key = line.substring(0, colonIndex);
+				String inlineValue = line.substring(colonIndex + 1);
+
+
+				if (!inlineValue.startsWith("~")) {
+					return new Entry(key, inlineValue);
+				}
+				value = new StringBuilder();
+				value.append(inlineValue.substring(1));
+				continue;
+			}
+			if (value.length() != 0) {
+				value.append(System.getProperty("line.separator"));
+			}
+			if (line.endsWith("~") && !line.endsWith("\\~")) {
+				value.append(line.substring(0, line.length() - 1));
+				return new Entry(key, value.toString().replaceAll("\\\\~", "~"));
+			}
+			value.append(line);
+		}
+		return null;
+	}
+
+	public static void load(Access access, Source source) {
+		Entry entry;
+		while ((entry = readEntry(source)) != null) {
+			Param param = access.getParam(entry.key);
+			if (param == null) {
+				throw new FramsticksException().msg("param not found in access").arg("name", entry.key).arg("access", access);
+			}
+			if (!(param instanceof ValueParam)) {
+				throw new FramsticksException().msg("param is not a value param").arg("param", param).arg("access", access);
+			}
+			if ((param.getFlags() & ParamFlags.DONTLOAD) == 0) {
+				int retFlags = access.set((ValueParam) param, entry.value);
+				if ((retFlags & (PSET_HITMIN | PSET_HITMAX)) != 0) {
+					String which = ((retFlags & PSET_HITMIN) != 0) ? "small" : "big";
+					log.warn("value of key '{}' was too {}, adjusted", entry.key, which);
+				}
+			}
+		}
+
+	}
+
+	public interface Adjuster {
+		public Holder<Object> adjust(ValueParam param);
+		public Class<? extends ValueParam> getParamType();
+	}
+
+	public static class MinAdjuster implements Adjuster {
+
+		/**
+		 *
+		 */
+		public MinAdjuster() {
+		}
+
+		@Override
+		public Class<? extends ValueParam> getParamType() {
+			return PrimitiveParam.class;
+		}
+
+		@Override
+		public Holder<Object> adjust(ValueParam param) {
+			Object value = ((PrimitiveParam<?>) param).getMin(Object.class);
+			if (value == null) {
+				return null;
+			}
+			return Holder.make(value);
+		}
+	}
+
+	public static class MaxAdjuster implements Adjuster {
+
+		/**
+		 *
+		 */
+		public MaxAdjuster() {
+		}
+
+		@Override
+		public Class<? extends ValueParam> getParamType() {
+			return PrimitiveParam.class;
+		}
+
+		@Override
+		public Holder<Object> adjust(ValueParam param) {
+			Object value = ((PrimitiveParam<?>) param).getMax(Object.class);
+			if (value == null) {
+				return null;
+			}
+			return Holder.make(value);
+		}
+	}
+
+	public static class DefAdjuster implements Adjuster {
+
+		protected final boolean numericOnly;
+
+		/**
+		 * @param numericOnly
+		 */
+		public DefAdjuster(boolean numericOnly) {
+			this.numericOnly = numericOnly;
+		}
+
+		public Class<? extends ValueParam> getParamType() {
+			return ValueParam.class;
+		}
+
+		@Override
+		public Holder<Object> adjust(ValueParam param) {
+			if (numericOnly && !(param.isNumeric())) {
+				return null;
+			}
+			return Holder.make(param.getDef(Object.class));
+		}
+	}
+
+	public static void adjustAll(Access access, Adjuster adjuster) {
+		for (ValueParam param : Containers.filterInstanceof(access.getParams(), adjuster.getParamType())) {
+			Holder<Object> value = adjuster.adjust(param);
+			if (value != null) {
+				access.set(param, value.get());
+			}
+		}
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/params/AccessProvider.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/AccessProvider.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/params/AccessProvider.java	(revision 101)
@@ -0,0 +1,8 @@
+package com.framsticks.params;
+
+public interface AccessProvider {
+
+	public Access getAccess(String name);
+	public void addAccess(Access access);
+
+}
Index: java/main/src/main/java/com/framsticks/params/ArrayListAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ArrayListAccess.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/params/ArrayListAccess.java	(revision 101)
@@ -24,5 +24,5 @@
 
 	@Override
-	public ArrayListAccess cloneAccess() throws ConstructionException {
+	public ArrayListAccess cloneAccess() {
 		return new ArrayListAccess(elementAccess.cloneAccess());
 	}
@@ -124,5 +124,5 @@
 	@Override
 	public ArrayListAccess select(Object object) {
-		list = Util.selectObjectForAccess(this, object, List.class);
+		list = ParamsUtil.selectObjectForAccess(this, object, List.class);
 		return this;
 	}
Index: java/main/src/main/java/com/framsticks/params/EventListeners.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/EventListeners.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/params/EventListeners.java	(revision 101)
@@ -0,0 +1,23 @@
+package com.framsticks.params;
+
+import java.util.LinkedList;
+import java.util.List;
+
+public class EventListeners<A> {
+
+	protected final List<EventListener<A>> listeners = new LinkedList<>();
+
+	public void add(EventListener<A> listener) {
+		listeners.add(listener);
+	}
+
+	public void remove(EventListener<A> listener) {
+		listeners.remove(listener);
+	}
+
+	public void actionForAll(A argument) {
+		for (EventListener<A> l : listeners) {
+			l.action(argument);
+		}
+	}
+}
Index: java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java	(revision 101)
@@ -5,6 +5,4 @@
 import java.lang.reflect.Member;
 import java.lang.reflect.Method;
-import java.lang.reflect.ParameterizedType;
-import java.lang.reflect.Type;
 import java.util.ArrayList;
 import java.util.Collections;
@@ -40,114 +38,4 @@
 	}
 
-	public static ParamBuilder induceParamType(ParamBuilder builder, Type type) {
-		// if (type.equals(Void.TYPE)) {
-		// 	throw new ConstructionException().msg("void is not a valid type");
-		// }
-
-		if (type instanceof ParameterizedType) {
-			ParameterizedType p = (ParameterizedType) type;
-			Type rawType = p.getRawType();
-			Type containedType = null;
-			//TODO make implementation here
-			boolean map = false;
-			StringBuilder b = new StringBuilder();
-			if (rawType.equals(Map.class)) {
-				containedType = p.getActualTypeArguments()[1];
-				map = true;
-				b.append("l");
-			} else if (rawType.equals(List.class)) {
-				containedType = p.getActualTypeArguments()[0];
-				b.append("l");
-			} else if (rawType.equals(EventListener.class)) {
-				containedType = p.getActualTypeArguments()[0];
-				b.append("e");
-			}
-			if (!(containedType instanceof Class)) {
-				return builder;
-			}
-			b.append(" ");
-
-			Class<?> containedClass = (Class<?>) containedType;
-			FramsClassAnnotation fca = containedClass.getAnnotation(FramsClassAnnotation.class);
-			if (fca == null) {
-				throw new ConstructionException().msg("the contained class is not annotated").arg("class", containedClass);
-			}
-			b.append(getName(fca, containedClass));
-			//TODO parametrize this
-			if (map) {
-				b.append(" uid");
-			}
-
-			builder.type(b.toString());
-			return builder;
-		}
-
-		if (type instanceof Class) {
-
-			Class<?> cl = (Class<?>) type;
-
-			// TODO: future support for enum
-			// if (cl.isEnum()) {
-			//	Class<? extends Enum<?>> enumType = (Class<? extends Enum<?>>) cl;
-			//	Enum<?>[] enums = enumType.getEnumConstants();
-			//	StringBuilder b = new StringBuilder();
-
-			//	b.append("d 0 ").append(enums.length - 1).append(" 0 ");
-			//	for (Enum<?> e : enums) {
-			//		b.append("~").append(e.name());
-			//	}
-			//	return b.toString();
-			// }
-			if (cl.equals(Integer.class) || cl.equals(int.class)) {
-				builder.type("d");
-				return builder;
-			}
-			if (cl.equals(String.class)) {
-				builder.type("s");
-				return builder;
-			}
-			if (cl.equals(Double.class) || cl.equals(double.class)) {
-				builder.type("f");
-				return builder;
-			}
-			if (cl.equals(Boolean.class) || cl.equals(boolean.class)) {
-				builder.type( "d 0 1");
-				return builder;
-			}
-			if (cl.equals(Object.class)) {
-				builder.type("x");
-				return builder;
-			}
-
-
-			// builder.type("o " + (cl).getCanonicalName());
-			builder.type("o " + cl.getSimpleName());
-			builder.fillStorageType(cl);
-			return builder;
-		}
-
-		throw new ConstructionException().msg("failed to find framsticks for native type").arg("type", type);
-	}
-
-
-	public static ParamBuilder induceParamType(ParamBuilder builder, ParamCandidate candidate) {
-		Method method = candidate.getCaller();
-		if (method == null) {
-			return induceParamType(builder, candidate.getType());
-		}
-
-		if (!method.getReturnType().equals(Void.TYPE)) {
-			builder.resultType(induceParamType(Param.build(), method.getGenericReturnType()).finish(ValueParam.class));
-		}
-
-		List<ValueParam> arguments = new ArrayList<>();
-		int number = 0;
-		for (Type arg : method.getGenericParameterTypes()) {
-			arguments.add(induceParamType(Param.build(), arg).idAndName("arg" + (number++)).finish(ValueParam.class));
-		}
-		builder.argumentsType(arguments);
-
-		return builder;
-	}
 
 	public static final String GENERATE_HELP_PREFIX = "automatically generated from: ";
@@ -238,5 +126,5 @@
 			ParamBuilder builder = Param.build().id(pc.getId()).name(pc.getName()).flags(pc.getFlags());
 
-			induceParamType(builder, pc);
+			pc.induceParamType(builder);
 
 			for (ParamAnnotation pa : pc.getAnnotations()) {
@@ -365,3 +253,5 @@
 	}
 
+
+
 }
